function out = zlib_uncompress(in,bytesize)

%zlib_uncompress(in,bytesize)


if nargin<2
bytesize = [];
end;

if isempty(bytesize)
bytesize = 8;
end;

if(bytesize ~= 8 && bytesize ~=32 && bytesize ~=64)
disp('Choose 8,32 or 64 for size\n');
return;
end;
warning('off','all');
if ~libisloaded('zlib')
if strcmp(computer('arch'),'glnx86')
  loadlibrary('libz.so','zlib.h','alias','zlib');
  pm = libpointer('uint32Ptr',m);
  n = uint32(2*length(in));
elseif strcmp(computer('arch'),'win32')
  loadlibrary('zlib1.dll','zlib.h','alias','zlib');
  pm = libpointer('uint32Ptr',m);
  n = uint32(2*length(in));
elseif strcmp(computer('arch'),'win64')
  loadlibrary('zlibwapi.dll','zlib.h','alias','zlib');
  pm = libpointer('uint32Ptr',m);
  n = uint32(2*length(in));
elseif strcmp(computer('arch'),'glnxa64')
  loadlibrary('/usr/lib64/libz.so','/usr/include/zlib.h','alias','zlib');
  pm = libpointer('uint32Ptr',m);
  n = uint32(2*length(in));
elseif strcmp(computer('arch'),'maci64')
  loadlibrary('libz.dylib','zlib.h','alias','zlib');
  pm = libpointer('uint64Ptr',m);
  n = uint64(2*length(in));
else
fprintf('Unknown OS');
return;
end;
end;

warning('on','all');

switch bytesize
	case 8
		str = 'uint8';
	case 32
		str = 'single';
	case 64
		str = 'double';
end



m = uint32(2*n);
while(1)

pin = libpointer('uint8Ptr',in);
out = zeros(1,m,'uint8');
pout = libpointer('uint8Ptr',out);

retval = calllib('zlib','uncompress',pout,pm,pin,n);
if retval == -5
   fprintf('Output buffer too small. Resizing\n');
   clear out;
   m = m*2;
elseif  retval == 0
break;
end;
end;
m = get(pm,'Value');
out = get(pout,'Value');
out = out(1:m);
out = typecast(out,str);

%unloadlibrary('zlib');
%outnow = zlib_uncompress_mex(in,bytesize)';
return;

m = unit32(100);
in = ones(m,'uint8');
n = uint32(200);
out = zeros(n,'uint8');